#include <windows.h>
#include <stdio.h>
#include "ddeml.h"
#include <string.h>
#include <stdlib.h>
#include <pdh.h>
#include "mirccom.h"
#include "./lsapi.h"

void mircCommand(HWND caller, const char* arg);
void mircChangeDDE(HWND caller, const char* arg);
DWORD dwidInst;
char mIRC[50];
//HMODULE msrsdll=NULL;

int initModule(HWND ParentWnd, HINSTANCE dllInst, wharfDataType* wd)
{
	return initModuleEx (ParentWnd, dllInst, wd->lsPath);
}

int initModuleEx(HWND ParentWnd, HINSTANCE dllInst, LPCSTR szPath)
{
	if(DdeInitialize(&dwidInst, LocationDdeCallBack, APPCLASS_STANDARD | APPCMD_CLIENTONLY, 0ul)){
		dwidInst = 0UL;
	}

	AddBangCommand("!mIRCCommand", mircCommand);
	AddBangCommand("!mIRCChangeDDE", mircChangeDDE);
	GetRCString("mIRCDDEName", mIRC, "mIRC", 50);

	return 0;
}

void quitModule(HINSTANCE dllInst)
{
	// clean up
	RemoveBangCommand("!mIRCCommand");
	RemoveBangCommand("!mIRCChangeDDE");
	DdeUninitialize(dwidInst);
}

void mircChangeDDE(HWND caller, const char* arg)
{
	char temp[256];
	strcpy(temp, arg);

	while (temp[strlen(temp)-1] == ' ' || temp[strlen(temp)-1] == '|' )
	{
		temp[strlen(temp)-1] = '\0';
	}
	strcpy(mIRC, temp);
}

void mircCommand(HWND caller, const char* arg)
{
	HCONV hConv = NULL;

	// connect to the mirc server
	HSZ hszService = DdeCreateStringHandle(dwidInst, mIRC, CP_WINANSI);
	HSZ hszTopic = DdeCreateStringHandle(dwidInst, "COMMAND", CP_WINANSI);
	hConv = DdeConnect(dwidInst, hszService, hszTopic, NULL);

	if(hConv == 0UL){
		char *sTemp = "Unable to start conversation with mIRC...";
		MessageBox(NULL,sTemp, "Error", MB_OK);
		return;
	}

	HSZ hszItem = DdeCreateStringHandle(dwidInst, arg, CP_WINANSI);
	HDDEDATA hRetVal = DdeClientTransaction((unsigned char *)arg, 255, hConv, hszItem, CF_TEXT, XTYP_POKE, 1000L, NULL);
}

HDDEDATA CALLBACK LocationDdeCallBack(UINT type, UINT fmt,
	HCONV hconv, HSZ hsz1, HSZ hsz2, HDDEDATA hData, DWORD dwData1,
	DWORD dwData2)	{
	
	// Being a simple client application not taking care of any transaction.
	// simply return NULL

	return (HDDEDATA) NULL;
}